// #define TOUCH_DEBUG

#include "LED.cpp"
#include "LEDOutput.cpp"
#include "TimerManager.cpp"
#include "TouchInput.cpp"
#include <Arduino.h>
#include <WiFi.h>

#define FADE_IN_DURATION 500
#define FADE_OUT_DURATION 1000

LEDOutput _ledOutput(0);
LED _ledStrip("cab", &_ledOutput, FADE_IN_DURATION, FADE_OUT_DURATION);

TouchInput _touchInput(32, 10, []() {
	_ledStrip.toggle();
});

void setup() {
	Serial.begin(115200);

	_ledOutput.attach(16);
}

void loop() {
	_ledStrip.loop();
	_touchInput.loop();
}