#ifndef BinaryInput_cpp
#define BinaryInput_cpp

#include <Arduino.h>

class BinaryInput {
	int _pin;
	bool _value;
	unsigned long _lastStateChangeMillis;

public:
	BinaryInput(int pin) {
		_pin = pin;
		pinMode(pin, INPUT_PULLDOWN);
	}

	void loop() {
		auto value = digitalRead(_pin);
		if (value != _value)
			_lastStateChangeMillis = millis();

		_value = value;
	}

	bool isHigh() {
		return _value;
	}

	unsigned long millisSinceLastStateChange() {
		return millis() - _lastStateChangeMillis;
	}
};

#endif