#ifndef PWMOutput_cpp
#define PWMOutput_cpp

#include <Arduino.h>

class PWMOutput {
	int _pin, _channel, _pwmMax, _pwmValue, _frequency, _resolution;
	bool _on;

	void writeOutput() {
		ledcWrite(_channel, _pwmValue * _on);
	}

public:
	PWMOutput(int pin, int frequency, int channel, int resolution = 8) {
		_pin = pin;
		_channel = _channel;
		_frequency=frequency;
		_resolution=resolution;
		_pwmMax = pow(2, resolution) - 1;

		pinMode(_pin, OUTPUT);
		ledcSetup(_channel, _frequency, _resolution);
		ledcAttachPin(_pin, _channel);

		off();
		setValueFraction(1);
	}

	void setValueFraction(float input) {
		_pwmValue = _pwmMax * input;
		writeOutput();
	}

	void on() {
		_on = true;
		writeOutput();
	}

	void off() {
		_on = false;
		writeOutput();
	}
};

#endif