#ifndef BluetoothLightControl_cpp
#define BluetoothLightControl_cpp

#include "LedManager.cpp"
#include <map>

class BluetoothLightControl{
	LedManager *_leds;

	unsigned long convertBytesToUnsignedLong(byte byte1, byte byte2, byte byte3, byte byte4) {
		return (unsigned long)byte1 << 24 | (unsigned long)byte2 << 16 | (unsigned long)byte3 << 8 | (unsigned long)byte4;
	}

  public:
	BluetoothLightControl(LedManager *leds){
		_leds = leds;
	}

	void action(std::string input){
		if (input.length() <= 0)
			return;

		auto data = input.data();
		for (int i = 0; i < input.length(); i += 10) {
			byte id = data[i];
			bool on = data[i + 1] == 1;
			float brightness = convertBytesToUnsignedLong(data[i + 2], data[i + 3], data[i + 4], data[i + 5])/100.0f;
			unsigned long timer = convertBytesToUnsignedLong(data[i + 6], data[i + 7], data[i + 8], data[i + 9]);

			_leds->setLedProperties(id, on, brightness, timer);
		}
	}
};

#endif
